%****************************************************************
%        Hochschule Hamm-Lippstadt                              *
%****************************************************************
% Modul	          : funktion_simulink_simultan_draufsicht.m     *
%                                                               *
% Datum           : 10-Okt-2012                                 *
%                                                               *
%                                                               *
% Implementation  : MATLAB R2013a                               *
%                                                               *
% Notw. Toolbox   : -                                           *
%                                                               *
% Autoren        : Gbel, Sbke, Ceranic, Dienwiebel u.A.       *
%                                                               *
% Bemerkung       :                                             *
%                                                               *
% Letzte nderung : 08.06.2017, Prof. Gbel                     *
%                                                               *
%***************************************************************/

function y = funktion_simulink_simultan_draufsicht(u)

global PAR_VIS_Anzahl_Schritte_n;

%% bergebene Parameter einlesen
zaehler         = u(1);
FZG_x_I_f64     = u(2);
FZG_y_I_f64     = u(3);
FZG_psi_f64     = u(4);
Schalter        = u(5);
Anzahl_Schritte = u(6);
breite          = u(7);
laenge          = u(8);

if Schalter == 1 
    % Unterscheidung 1. Simulationsschritt oder nicht
    if zaehler == 1
        % Variablen nur beim ersten Simulationsschritt anlegen und global
        % setzen.
        evalin('base', 'global plot_puffer_x plot_puffer_y')
        global plot_puffer_x plot_puffer_y
        
        % Figure zur Darstellung fr alle Bahn-Anzeigen ffnen
        figure, hold on, axis equal, grid off, box on
        %% TODO: noch einfgen, um die Karte etc einzuzeichnen: 
        % plot(PAR_SenKam_BahnZ_f64(1,:), PAR_SenKam_BahnZ_f64(2,:), 'b') % Vorgegebene Fahrbahn
        % legend('Bahn')
        
        % Startposition bernehmen
        plot_puffer_x   = FZG_x_I_f64;
        plot_puffer_y   = FZG_y_I_f64;
              
        % Simulation der Fahrbahn und des Fahrzeugs (erstmalig)
        % TODO: Fahrbahn dazu zeichnen
        fahrzeug(zaehler, breite, laenge, FZG_psi_f64, FZG_x_I_f64, FZG_y_I_f64);
        xlabel('x_I [m]');
        ylabel('y_I [m]');
        
    else
        % Variablen nur global setzen, damit hier in der Funktion verfgbar.
        global plot_puffer_x plot_puffer_y
        plot_puffer_x(end+1, 1) = u(2); % gefahrene Bahn, x-Wert
        plot_puffer_y(end+1, 1) = u(3); % gefahrene Bahn, y-Wert
    end
    
    % Alle VIS_Anzahl_Schritte_n Schritte die gefahrende Bahn plotten
    if mod(length(plot_puffer_x), Anzahl_Schritte) == 0
        plot(plot_puffer_x, plot_puffer_y, 'r', 'LineWidth', 2)
        grid on;
        fahrzeug(zaehler, breite, laenge, FZG_psi_f64, FZG_x_I_f64, FZG_y_I_f64)
        pause(0.01);
    end
    
    % Richtungsvektor alle 50 Schritte plotten
%     if mod(length(plot_puffer_x), 50) == 0
%         % Abstnde in x und y vom jetzigen und vorherigen Punkt bestimmen
%         % Abfangen, dass am Anfang in plot_puffer zu wenig Werte enthalten
%         % sind!
%         if length(plot_puffer_x) <= 2
%             delta_x = 0;
%             delta_y = 0;
%         else
%             delta_x = plot_puffer_x(end,1) - plot_puffer_x(end-1,1); % Steigungsanteil x
%             delta_y = plot_puffer_y(end,1) - plot_puffer_y(end-1,1); % Steigungsanteil y
%         end
%         
%         % Neuen, prdizierter Punkt bei aktueller Richtung bestimmen
%         punkt_neu_x = 500*delta_x + plot_puffer_x(end,1);
%         punkt_neu_y = 500*delta_y + plot_puffer_y(end,1);
%         
%         %plot([plot_puffer_x(end) punkt_neu_x], [plot_puffer_y(end) punkt_neu_y], '-k')
%         arrowline([plot_puffer_x(end) punkt_neu_x], [plot_puffer_y(end) punkt_neu_y]);
%     end
       
    
end

%% Funktion abschlieen (Dummy-Wert bergeben)
y = 1;